if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler");
dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler", 
		[dijit._Widget, dijit._Templated], {
	boundNode : null,		
	
	templateString : "<div class='toggler'><div role='button' aria-expanded='false' tabindex='0' class='togglerNode'><img class='togglerImg'></img></div></div>",
	loaded: false,
			
	constructor : function() {
		this._expanded = true;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	},
	
	postCreate : function() {
		if (this.boundNode) {
			this._toggler = {
				node: this.boundNode,
				show: function() {
					dojo.style(this.node, "display", "block");
				},
				hide: function() {
					dojo.style(this.node, "display", "none");
				}
			};
		}
		this._togglerNode = dojo.query(".togglerNode", this.domNode)[0];
        dojo.attr(this._togglerNode, "aria-label", this._bundle.I_SPACEMANAGER_SHOW_OR_HIDE);
		this._togglerImgNode = dojo.query(".togglerImg", this.domNode)[0];
		dojo.attr(this._togglerImgNode, "alt", "");
		this.connect(this._togglerNode, "onclick", this._toggle);
		this.connect(this._togglerNode, "onkeypress", this._enteredByKey);
		
		this._toggle();
	},
	
	_enteredByKey: function(evt){
		
		if (evt.keyCode != dojo.keys.ENTER && evt.charCode != dojo.keys.SPACE) {
			return;
		}
		this._toggle();
		
		evt.preventDefault();					                  
	},
	
	expanded : function() {
		dojo.addClass(this._togglerNode, "toggler_expanded");
        dojo.attr(this._togglerNode, "aria-expanded", "true");
		dojo.removeClass(this._togglerNode, "toggler_collapsed");
		dojo.attr(this._togglerImgNode, "src", "images/spacemanager/expanded.gif");
		if (!this.loaded) {
			this._loadPages();
		}
			
		//ARIA
		//if (this.level === 0) {
			//dojo.attr(this.boundNode.parentNode.parentNode, "aria-expanded", "true");
		//}
		//else {
			//dojo.attr(this.boundNode.parentNode, "aria-expanded", "true");
		//}
	},
	
	_isPageHidden : function(page) {
		return page.isHidden();
	},
	
	_canEditPage : function(page) {
		return this.pageUtil.canEdit(page);
	},
	
	_loadPages: function(){
		var pagesNode = this.boundNode;
		pagesNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._doLoadPages));
	},
	
	_doLoadPages : function() {
		
		var count = 0;
		var pagesNode = this.boundNode;
        dojo.attr(this._togglerNode, "aria-controls", pagesNode);
		var navMode = this.navigationUtil.getNavigationModel();	
		
		var parentPage = (this.parentPage == null)? navMode.find(this.parentPageId).start() : this.parentPage;		
		
		var hasChildren = navMode.hasChildren(parentPage);
		
		if (!hasChildren) {
			this.destroy();			
		}
			
		var iterator = navMode.getChildren(parentPage);
		
		pagesNode.innerHTML = "";
		
		while (iterator.hasNext()) {
			var page = iterator.next();
			if (!this._isPageHidden(page) || this._canEditPage(page)) {
				var pageNode = dojo.create("div", {}, pagesNode);
				var pageOwner = "";
				if (this._constants.showPageOwner === "true") {
					pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, page);
				}
				
				var pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
					pageMeta: {
						title: this.enablerUtil.getNodeTitle(page) || this._bundle.I_SPACE_MANAGER_NO_TITLE,
						description: this.enablerUtil.getNodeDescription(page) || this._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
						owner: pageOwner,
						level: this.level + 1,
						space: this.space,
						page: page,
						pageId: page.getID()
					}
				}, pageNode);
				if (this._isPageHidden(page)) {
					dojo.addClass(pageItem.domNode, "hidden_page");
					dojo.addClass(pageItem._flagNode, "hidden_flag");
				}
				count++;
			}
		}
		
		this.loaded = true;
	},
	
	collapsed : function() {
		dojo.removeClass(this._togglerNode, "toggler_expanded");
        dojo.attr(this._togglerNode, "aria-expanded", "false");
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);

		if (cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CLIENT_IS_BIDI)){
			dojo.attr(this._togglerImgNode, "src", "images/spacemanager/expand_rtl.gif");
		} else {
			dojo.attr(this._togglerImgNode, "src", "images/spacemanager/expand.gif");
		}
		
		dojo.addClass(this._togglerNode, "toggler_collapsed");
		
		//ARIA
		//if (this.level === 0) {
			//dojo.attr(this.boundNode.parentNode.parentNode, "aria-expanded", "false");
		//}
		//else {
			//dojo.attr(this.boundNode.parentNode, "aria-expanded", "false");
		//}
	},
	
	_toggle : function() {
		var func = this._expanded ? "hide" : "show";
		var callback = this._expanded ? "collapsed" : "expanded";
		if (this._toggler) {
			this._toggler[func].apply(this._toggler);
		}
		this[callback].apply(this);
		this._expanded = !this._expanded;
	}
});

}
