dojo.require("com.ibm.widgets.Breadcrumbs");
dojo.require("com.ibm.mm.builder.navigationHelper");
dojo.require("com.ibm.pb.iwidget.iWidgetBase");

dojo.declare("com.ibm.mm.builder.systemwidget.Breadcrumb", com.ibm.pb.iwidget.iWidgetBase, {
	
	startLevel: 1,
	
	controller: null,
	
	//TODO: Mashup 3.0 temp fixes for Mashup navigation problem, all code related to varyLevelInSpace is required.
	varyLevelInSpace: false,
	
	attachNode: null,
	
	onLoad: function(){
		var mname = "onLoad", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.navWidgetBundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
		
		var attrMix = this.getItemSetValues([
			"attachNode", // Strings
			"startLevel","levels", // Numbers
			"containerClass","listClass","siblingSeparator",	// Strings
			"renderSiblings","varyLevelInSpace", // Boolean
			"controller"	// Object
			]);
		this.convertMapTypes(attrMix, ["startLevel","levels"], "Number");
		this.convertMapTypes(attrMix, ["renderSiblings","varyLevelInSpace"], "Boolean");
		this.convertMapTypes(attrMix, ["controller"], "Object");
		
		this.startLevel = attrMix.startLevel;
		
		dojo.forEach(["controller","attachNode","varyLevelInSpace"], function(key){
			this[key] = attrMix[key];
			delete attrMix[key];
		}, this);
		
		if(this.varyLevelInSpace && this.controller.getCurrentSpaceId()) {
			// Increment the level by one if we're in a space
			attrMix.startLevel++;
		}
		
		var initArgs = dojo.delegate({
			model: this.controller.getSelectionModel(),
			startLevel: 1,
			renderSiblings: false,
			siblingSeparator: "",
			allowNew: false,
			listDOM: "span",
			itemDOM: "span",
			listClass: "lotusBreadcrumbs",
			containerClass: "ibmPortalBreadcrumbs lotusLeft",
			onClickItem: function(item){ 
				return;
			}
		}, attrMix);
		
		if(this.attachNode) {
			this.attachNode = dojo.byId(this.attachNode);
		}
		if(!this.attachNode) {
			this.attachNode = this.iContext.getRootElement();
		}
		
		this.breadcrumb = new com.ibm.widgets.Breadcrumbs(initArgs, this.attachNode);

		this.breadcrumb.createDomLink = function(item, className, separator, node){
			var domItem = document.createElement(this.itemDOM);
			dojo.addClass(domItem, className);
			var link = document.createElement("a");
			domItem.appendChild(link);
			domItem.appendChild(document.createTextNode(separator));
			link.innerHTML = this.treeModel.getLabel(item);
			link.href = "javascript:;";
			if (ibmCfg.themeConfig.isPageRenderModeCSA) {
				dojo.connect(link, "onclick", dojo.hitch(this, function(){ 
					var cb = dojo.hitch(this, function(){
						var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
						es.broadcastEvent("com.ibm.mashups.builder.switchPage", this.treeModel.getIdentity(item));
					});
					com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
				}));
			}else{
				dojo.connect(link, "onclick", dojo.hitch(this, function(){ 
					var cb = dojo.hitch(this, function(){
						var pid =  this.treeModel.getIdentity(item);
						com.ibm.mm.builder.utils.pageUtil.setPageId(pid);
						var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
						var redirectAddress = com.ibm.mashups.enabler.model.state.UrlGeneratorFactory.getUrlGenerator().getUrl(navStateModel);
						setTimeout(function(){location.href = redirectAddress;}, 10);
						return;
					});
					com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);	
				}));
			}
			this.trail.insertBefore(domItem, node);
			return domItem;
		}
		
		this.breadcrumb.startup();
		
		lgr.exiting(mname, arguments);
	},
	onRefreshNavigation:function(iEvent){
		var mname = "onRefreshNavigation", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		try{
			this.refresh(iEvent.payload);
		}catch(e){
			var msg = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_REFRESH_NAVIGATION_1,[e.message]);
			lgr.severe(mname, msg);
		}
		lgr.exiting(mname, arguments);
	},
	onPageSwitched:function(iEvent){
		var mname = "onPageSwitched", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		try{
			if(this.varyLevelInSpace && this.controller.getCurrentSpaceId() && this.breadcrumb.startLevel == this.startLevel) {
				lgr.trace(mname, "Navigated into a space, reset level of breadcrumb widget ${0} to ${1}", [this, this.startLevel + 1]);
				this.breadcrumb.attr("startLevel", this.startLevel + 1);
				this.refresh(iEvent.payload);
			}
			if(this.varyLevelInSpace && !this.controller.getCurrentSpaceId() && this.breadcrumb.startLevel == this.startLevel + 1) {
				lgr.trace(mname, "Navigated into a space, reset level of nav widget ${0} to ${1}", [this, this.startLevel]);
				this.breadcrumb.attr("startLevel", this.startLevel);
				this.refresh(iEvent.payload);
			}
		}catch(e){
			var msg = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAVIGATION_SWITCH_PAGE_1,[e.message]);
			lgr.severe(mname,msg);
		}
		lgr.exiting(mname, arguments);
	},
	refresh: function(pid){
		var mname = "refresh", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.breadcrumb.redraw(); 
		lgr.exiting(mname, arguments);
	},
	onUnload: function(){
	    if (this.breadcrumb != null) {
			this.breadcrumb.destroy();
	        this.breadcrumb = null;
	    } 
	}
});
