/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.services.StrategyService");

//<INTERFACE>

/**
 * Interface allowing to set strategies without the need to actively fetch the model and set it.
 * @ibm-spi
 * @ibm-module CoreModel
 * @since 3.0.0.1
 */
dojo.declare("com.ibm.mashups.enabler.services.StrategyService", null, {
    /**
     * The service name to be used to fetch the service from the ServiceManager
     * @type String
     */
    SERVICE_NAME: "strategyService",

    /**
     * Sets the specified array of strategies or in case none has been
     * defined falls back to the default strategy
     * @param {String} model class name of the model that strategy belongs to
     * @param {com.ibm.mashups.enabler.strategy.Strategy[]}  strategy    array of strategies to set;
     *                                  may be <code>null</code>
     * @type void
     */
    setStrategy : function(model, strategy) {
    },

    /**
     * Returns the array of strategies which are in use
     * @param {String} model class name of the model that strategy belongs to
     * @return {com.ibm.mashups.enabler.strategy.Strategy[]} array of strategies in use, <code>null</code> if no
     *                      strategies are in use
     */
    getStrategies : function(model) {
    },

    /**
     * Returns the specified strategy
     * @param {String} model class name of the model that strategy belongs to
     * @param {strategy} strategy class name or array index of strategy
     * @return {com.ibm.mashups.enabler.strategy.Strategy} strategy in use, <code>null</code> if no
     * strategy with the specified type is in use
     * @ibm-spi
     */
    getStrategy : function(model, strategy) {
    },

    /**
     * Adds a strategy to the strategies array
     * @param {String} model class name of the model that strategy belongs to
     * @param {com.ibm.mashups.enabler.strategy.Strategy} strategy strategy to add; must not be <code>null</code>
     * @return {int} index where the strategy was added in the strategies array
     */
    addStrategy : function(model, strategy) {
    },

    /**
     * Removes the specified strategy
     * @param {String} model class name of the model that strategy belongs to
     * @param {strategy} strategy class name or array index of the strategy; must not be
     * <code>null</code>
     * @type void
     */
    removeStrategy : function(model, strategy) {
    }
});

// make sure we can reference this globally
com.ibm.mashups.enabler.services.StrategyService.SERVICE_NAME = "strategyService";

//</INTERFACE>

dojo.require("com.ibm.mm.enabler.services.StrategyServiceImpl");
