-- ***************************************************************** 
--                                                                   
-- Licensed Materials - Property of IBM                              
--                                                                   
-- 5724-U69                                                          
--                                                                   
-- Copyright IBM Corp. 2011  All Rights Reserved.                    
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
--                                                                   
-- ***************************************************************** 

-- CREATE BUFFERPOOL MASHUPS32KBP IMMEDIATE SIZE 8000 AUTOMATIC PAGESIZE 32K;
--     
-- CREATE SYSTEM TEMPORARY TABLESPACE @TSPRE@TMPTP
--     PAGESIZE 32K MANAGED BY SYSTEM 
--     USING ( '@TSDIR@TMPTP' ) 
--     EXTENTSIZE 16
--     BUFFERPOOL MASHUPS32KBP
--     FILE SYSTEM CACHING
-- ;

-- CREATE REGULAR TABLESPACE @TSPRE@REGTP
--     PAGESIZE 32K MANAGED BY SYSTEM
--     USING ( '@TSDIR@REGTP' )
--     EXTENTSIZE 16
--     BUFFERPOOL MASHUPS32KBP
--     FILE SYSTEM CACHING
-- ;

----------------------------------------------------------------------------------
-- For improved performance on DB2 v9.x, you can instead use the following blocks:
----------------------------------------------------------------------------------
-- CREATE BUFFERPOOL MASHUPS32KBP IMMEDIATE SIZE 8000 AUTOMATIC PAGESIZE 32K;
--    
-- CREATE SYSTEM TEMPORARY TABLESPACE @TSPRE@TMPTP
--     PAGESIZE 32K MANAGED BY SYSTEM 
--     USING ( '@TSDIR@TMPTP' ) 
--     EXTENTSIZE 16
--     PREFETCHSIZE AUTOMATIC
--     BUFFERPOOL MASHUPS32KBP
--     FILE SYSTEM CACHING
-- ;
--
-- CREATE REGULAR TABLESPACE @TSPRE@REGTP
--     PAGESIZE 32K MANAGED BY SYSTEM
--     USING ( '@TSDIR@REGTP' )
--     EXTENTSIZE 16
--     PREFETCHSIZE AUTOMATIC
--     BUFFERPOOL MASHUPS32KBP
--     NO FILE SYSTEM CACHING
-- ;

------------- bufferpool for regular tablespaces
CREATE BUFFERPOOL BP32K_BSP IMMEDIATE SIZE 250 PAGESIZE 32 K;

------------- bufferpool for temp tablespace
CREATE BUFFERPOOL TMPBP32K_BSP IMMEDIATE SIZE 250 PAGESIZE 32 K;

------------- tablespace for DataServices (DS) 
CREATE REGULAR TABLESPACE @TSPRE@BSPACE PAGESIZE 32 K  
MANAGED BY SYSTEM  USING ('@TSDIR@BS' ) 
EXTENTSIZE 8 OVERHEAD 10.5 PREFETCHSIZE 0 TRANSFERRATE 0.14 
BUFFERPOOL BP32K_BSP DROPPED TABLE RECOVERY OFF;

------------- tablespace (temp) for sorts/joins
CREATE SYSTEM TEMPORARY TABLESPACE @TSPRE@TMPT_BS PAGESIZE 32 K  
MANAGED BY SYSTEM USING ('@TSDIR@TMPT_BS' ) 
EXTENTSIZE 8 OVERHEAD 10.5 PREFETCHSIZE 32 TRANSFERRATE 0.14 
BUFFERPOOL TMPBP32K_BSP;
